*-----------------------------------------------------------------------
*     TMSTLN : THE ROUTINE FOR DRAWING STREAM LINES
*-----------------------------------------------------------------------
*     COPYRIGHT (C) 2000-2012 GFD DENNOU CLUB. ALL RIGHTS RESERVED.
*-----------------------------------------------------------------------
      SUBROUTINE TMSTLN( X, Y, U, V, NX, NY, TRX, TRY, NM )

      IMPLICIT NONE

*-- AGREENMENT
      INTEGER NX                !* GRID NUMBERS FOR X-DIRECTION
      INTEGER NY                !* GRID NUMBERS FOR Y-DIRECTION
      REAL    U(NX,NY)          !* VECTOR COMPONENT OF X-DIRECTION
      REAL    V(NX,NY)          !* VECTOR COMPONENT OF Y-DIRECTION
      REAL    X(NX)             !* GRID POINTS OF X-DIRECTION [UNIT:LENGTH]
      REAL    Y(NY)             !* GRID POINTS OF Y-DIRECTION [UNIT:LENGTH]
      REAL    TRX(NX*NY,NX*NY)  !* STREAM LINE OF X-COORDINATE
      REAL    TRY(NX*NY,NX*NY)  !* STREAM LINE OF Y-COORDINATE
      INTEGER NM(NX*NY)         !* ARRAY NUMBER IN EACH STREAM LINE

*-- INTERNAL VARIABLES
      INTEGER I, J, K, L        !* TMP VALUES
      INTEGER COUNTER           !* NUMBER OF STREAM LINE
      INTEGER GRID_NUM(NX,NY)
      INTEGER INVERSE_COUNTER
      INTEGER THRES
      INTEGER SKIP
      REAL    ARROW_THRES
      REAL    DT
      REAL    DTX, DTY
      REAL    UNDEF             !* UNDEFINED VALUE FOR DCL
      REAL    TMPX(NX*NY)
      REAL    TMPY(NX*NY)
      CHARACTER(10) RCHARC
      CHARACTER(3)  ICHARC
      LOGICAL PFX, PFY

      CALL GLRGET( 'RMISS', UNDEF )

*-- GETTING TMPACK'S PARAMETERS
      CALL TMIGET( 'GRDTHRES', THRES )
      CALL TMIGET( 'SKIPINTV', SKIP )
      CALL TMRGET( 'ARRWINTV', ARROW_THRES )
      CALL TMLGET( 'PERIODX', PFX )
      CALL TMLGET( 'PERIODY', PFY )
*      CALL TMVGET( THRES, SKIP, ARROW_THRES )  !* STPACK GETTING ROUTINE

*-- INITIALIZING GRID_NUM (COUNTER FOR PASSING STREAM LINES IN EACH GRID)
*-- ʻ̲ήΥѿ
      DO 11 J=1,NY
         DO 10 I=1,NX
            GRID_NUM(I,J)=0
 10      CONTINUE
 11   CONTINUE

      COUNTER=1

*-- DETERMINING "DT" (DT=DXMIN/VMAX)
*-- ʲή׻κݤʬˤ
*-- CFL Τ褦ʤΤꤹ.
**      MAXV=0.0

**      DO 31 J=1,NY
**         DO 30 I=1,NX
**            IF(U(I,J).NE.UNDEF.AND.V(I,J).NE.UNDEF)THEN
**               VTMP=SQRT(U(I,J)**2+V(I,J)**2)
**               IF(VTMP.GT.MAXV)THEN
**                  MAXV=VTMP
**               END IF
**            END IF
** 30      CONTINUE
** 31   CONTINUE

**      MINR=X(2)-X(1)
**
**      DO 40 I=2,NX
**         XTMP=X(I)-X(I-1)
**         IF(XTMP.LT.MINR)THEN
**            MINR=XTMP
**         END IF
** 40   CONTINUE
**
**      DO 41 J=2,NY
**         XTMP=Y(J)-Y(J-1)
**         IF(XTMP.LT.MINR)THEN
**            MINR=XTMP
**         END IF
** 41   CONTINUE

*-- INITIALIZING
      CALL TMRGET( 'STLNDT', DT )

      IF(DT.LE.0.0)THEN
         DO 31 J=2,NY
            DO 30 I=2,NX
               IF(U(I,J).NE.UNDEF.AND.U(I-1,J).NE.UNDEF.AND.
     &            V(I,J).NE.UNDEF.AND.V(I,J-1).NE.UNDEF)THEN
                  IF(U(I,J)+U(I-1,J).NE.0.0)THEN
                     DTX=2.0*abs((X(I)-X(I-1))/(U(I,J)+U(I-1,J)))
                  ELSE
                     DTX=DT
                  END IF
                  IF(V(I,J)+V(I,J-1).NE.0.0)THEN
                     DTY=2.0*abs((Y(J)-Y(J-1))/(V(I,J)+V(I,J-1)))
                  ELSE
                     DTY=DT
                  END IF
        
                  IF(DT.NE.0.0)THEN
                     IF(DT.GT.DTX)THEN
                        DT=DTX
                     END IF
                     IF(DT.GT.DTY)THEN
                        DT=DTY
                     END IF
                  ELSE
                     IF(DTX.NE.0.0)THEN
                        DT=DTX
                     END IF
                     IF(DTY.NE.0.0)THEN
                        DT=DTY
                     END IF
                  END IF
               END IF
 30         CONTINUE
 31      CONTINUE
      END IF

      CALL MSGDMP( 'M', 'TMSTLN', 'CHECKING EACH PARAMETER' )
      WRITE(ICHARC(1:3),'(I3)') THRES
      CALL MSGDMP( 'M', 'TMSTLN', 'THRES       ===> '//ICHARC(1:3) )
      WRITE(ICHARC(1:3),'(I3)') SKIP
      CALL MSGDMP( 'M', 'TMSTLN', 'SKIP        ===> '//ICHARC(1:3) )
      WRITE(RCHARC(1:10),'(1P,E10.3)') ARROW_THRES
      CALL MSGDMP( 'M', 'TMSTLN', 'ARROW THRES ===> '//RCHARC(1:10) )
      WRITE(RCHARC(1:10),'(1P,E10.3)') DT
      CALL MSGDMP( 'M', 'TMSTLN', 'DT          ===> '//RCHARC(1:10) ) 

*-- ʾε CFL 狼ʬƥåפ.
**      DT=MINR/MAXV

*-- STARTING TO CALCULATE STREAM LINES.
*-- DETERMINING STARTING POINT BY USING A PARAMETER VALUE "SKIP".
*-- ΰζή׻Ԥ.
*-- GRID_NUM ˤä, ̲ᤷƤʤʻҤϸƤΤ, 
*-- γʻҤˤĤ SKIP ֳ֤ή׻Ԥ.
      DO 61 J=1,NY
         IF(MOD((J-1),SKIP).EQ.0.OR.J.EQ.NY)THEN
            DO 60 I=1,NX
               IF(MOD((I-1),SKIP).EQ.0.OR.I.EQ.NX)THEN
                  IF(U(I,J).NE.0.0.OR.V(I,J).NE.0.0)THEN  !* ʻ®ʤ TMSLCL ʤ.
                     TRX(1,COUNTER)=X(I)
                     TRY(1,COUNTER)=Y(J)
                     INVERSE_COUNTER=COUNTER  ! շ׻Ѥήֹ
                     IF(GRID_NUM(I,J).LT.THRES)THEN
                        DO 62 K=INVERSE_COUNTER,NX*NY  !* ͤϼꤹʵ⤹.
                           CALL TMRSET( 'STLNDT', DT )
                           CALL TMSLCL( TRX(1,COUNTER), TRY(1,COUNTER),
     &                                  NX, NY, X, Y, U, V,
     &                                  TRX(:,COUNTER), TRY(:,COUNTER),
     &                                  NM(COUNTER), GRID_NUM )
                           COUNTER=COUNTER+1

*-- ήѰդʾϢ³, ǽޤǷ׻.
                           IF(NM(COUNTER-1).LT.NX*NY)THEN
                              IF(I.NE.1.AND.I.NE.NX.AND.
     &                           J.NE.1.AND.J.NE.NY)THEN
                                 GO TO 63  !* äƤеշ׻ (ΰ¦) .
                              ELSE  !* äƤ, ʤ鶭夬Ǥεշ׻, Ǥʤмή׻.
                                 IF(PFX.EQV..TRUE.)THEN
                                   IF(I.EQ.1.OR.I.EQ.NX)THEN
                                      GO TO 63
                                   ELSE
                                      GO TO 999
                                   END IF
                                 ELSE
                                    GO TO 999
                                 END IF

 999                             IF(PFY.EQV..TRUE.)THEN
                                   IF(J.EQ.1.OR.J.EQ.NY)THEN
                                      GO TO 63
                                   ELSE
                                      GO TO 60
                                   END IF
                                 ELSE
                                    GO TO 60  !* äƤмή׻ (ΰ趭)
                                 END IF
                              END IF
                           END IF

                           IF(K.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
                           TRX(1,COUNTER)=TRX(NX*NY,COUNTER-1)
                           TRY(1,COUNTER)=TRY(NX*NY,COUNTER-1)
 62                     CONTINUE

*-- CALCULATING INVERSE DIRECTION.
*-- "TMSLCL" CAN CALCULATE FORWARD DIRECTION FOR "DT>0",
*-- BACKWARD DIRECTION FOR "DT<0".
*-- ήΰǳϤƤΤ, ոˤ׻.
*-- DT ĤƵõ.
*-- GRID_NUM(I,J) ׻ǥȤƤΤ, ΥȤ򳰤Ƥ
 63                     GRID_NUM(I,J)=GRID_NUM(I,J)-1
                        TRX(1,COUNTER)=TRX(1,INVERSE_COUNTER)
                        TRY(1,COUNTER)=TRY(1,INVERSE_COUNTER)

                        DO 64 K=INVERSE_COUNTER,NX*NY
                           CALL TMRSET( 'STLNDT', -DT )  ! ո׻Τ, Ĥ
                           CALL TMSLCL( TRX(1,COUNTER), TRY(1,COUNTER),
     &                                  NX, NY, X, Y, U, V, 
     &                                  TMPX(:), TMPY(:),
     &                                  NM(COUNTER), GRID_NUM )

*-- շ׻ʬ TRX, TRY ˳Ǽ.
*-- , ո׻ʤΤ, ϵդ.
                           IF(NM(COUNTER).GT.1)THEN
                              DO 70 L=1,NM(COUNTER)
                                 TRX(L,COUNTER)=TMPX(NM(COUNTER)-L+1)
                                 TRY(L,COUNTER)=TMPY(NM(COUNTER)-L+1)
 70                           CONTINUE
                           END IF
                           COUNTER=COUNTER+1

*-- ήѰդʾϢ³, ǽޤǷ׻.
                           IF(NM(COUNTER-1).LT.NX*NY)THEN
                              GO TO 60  !* äƤмή׻
                           END IF
                           IF(K.EQ.NX*NY)THEN
                              CALL MSGDMP( 'W', 'TMSTLN', 
     &                                     'ARRAY WILL BE OVER FLOW.')
                              GO TO 100
                           END IF
                           TRX(1,COUNTER)=TMPX(NX*NY)
                           TRY(1,COUNTER)=TMPY(NX*NY)
 64                     CONTINUE
                     END IF
                  END IF
               END IF
 60         CONTINUE
         END IF
 61   CONTINUE

 100  CALL MSGDMP( 'M', 'TMSTLN', 'CALCULATING FINISHED.' )

      COUNTER=COUNTER-1

      CALL TMISET( 'STLNNUM', COUNTER )

      END SUBROUTINE TMSTLN

